%        
%    (), 
%  tau -  , w0=2*pi*f0-  .

%     
close all
%    (WORKSPACE)
clear

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                       %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





% T -   , 
T=4;
% N -      
N=256;
% K -    
K=20;
% k, O -  
k=8388608./20480; 
O=64./27;
% dt -    
dt=T/N;
% df -    
df=1./(N.*dt);
% t -      
t=(0:dt:T-dt)';
% f -   ,       
f=(-0.5/dt:df:0.5/dt-df)';
% R -      
% Sp -       
% 
% Sp -     
Sp=k.*((2*pi*f(1:N)).^4./(((2*pi*f(1:N)).^2+O.^2)).^3);
Sp=[Sp(N/2+1:N); Sp(1:N/2)];
R=(fft(Sp)).*df;
R=[R(N/2+1:N); R(1:N/2)];
%     
figure(1)
plot(f,fftshift(Sp))
title('  ')
xlabel('f, ')
ylabel('S(f)')
grid

% Dp -        
Dp=sqrt(Sp)/sqrt(2);
Re=zeros(N,1);Ree=Re;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                            %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% M -      
M=N/2;
%      
for k=1:K
   % Ar, Ai -    . 
   Ar=randn(size(Dp(1:M)));Ai=randn(size(Dp(1:M)));
   % Aleft, Aright -     . 
   Aleft=Ar+i*Ai;
   Ar=randn(size(Dp(1:M)));Ai=randn(size(Dp(1:M)));
   Aright=Ar+i*Ai;
   % Aa -       
   Aa=[Aleft.*Dp(1:M); zeros(N-2*M,1); Aright.*Dp(N-M+1:N)];
   % S - k-   ,     FFT
   S=fft(Aa);
   S=S./2

%   k-   
figure(2)
plot(t,[real(S) imag(S)]);
title(['  , k=' int2str(k)])
xlabel('t, ')
ylabel('s(t)')
grid
%pause(1)

%      
Aa=Aa.*conj(Aa);
% Ree -    k-   
Ree=(fft(Aa)).*df;
% Re - ,        
Re=Re+Ree;
end

Re=[Re(N/2+1:N); Re(1:N/2)];
%     
Re=Re./K;
% R       
R=[R Re];
R=R./max(max(R)); % !!!

%   : 
% -  ,  
% -  ,  
figure(3)
title(' :    ')
subplot(211);plot(t-0.5*T,real(R))
xlabel('\tau, c')
ylabel('Re\{R(\tau)\}')
grid
subplot(212);plot(t-0.5*T,imag(R))
xlabel('\tau, c')
ylabel('Im\{R(\tau)\}')
grid
